#pragma once

#if (defined(_WIN32) || defined(__CYGWIN__)) && !defined(GDK_STATIC_COMPILATION)
#  define _GDK_EXPORT __declspec(dllexport)
#  define _GDK_IMPORT __declspec(dllimport)
#elif __GNUC__ >= 4
#  define _GDK_EXPORT __attribute__((visibility("default")))
#  define _GDK_IMPORT
#else
#  define _GDK_EXPORT
#  define _GDK_IMPORT
#endif
#ifdef GTK_COMPILATION
#  define _GDK_API _GDK_EXPORT
#else
#  define _GDK_API _GDK_IMPORT
#endif

#define _GDK_EXTERN _GDK_API extern

#define GDK_VAR _GDK_EXTERN
#define GDK_AVAILABLE_IN_ALL _GDK_EXTERN

#ifdef GDK_DISABLE_DEPRECATION_WARNINGS
#define GDK_DEPRECATED _GDK_EXTERN
#define GDK_DEPRECATED_FOR(f) _GDK_EXTERN
#define GDK_UNAVAILABLE(maj,min) _GDK_EXTERN
#define GDK_UNAVAILABLE_STATIC_INLINE(maj,min)
#else
#define GDK_DEPRECATED G_DEPRECATED _GDK_EXTERN
#define GDK_DEPRECATED_FOR(f) G_DEPRECATED_FOR(f) _GDK_EXTERN
#define GDK_UNAVAILABLE(maj,min) G_UNAVAILABLE(maj,min) _GDK_EXTERN
#define GDK_UNAVAILABLE_STATIC_INLINE(maj,min) G_UNAVAILABLE(maj,min)
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_0
#define GDK_DEPRECATED_IN_4_0 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_0_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_0 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_0_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_0 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_0_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_0 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_0_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_0 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_0_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_0
#define GDK_DEPRECATED_MACRO_IN_4_0_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_0
#define GDK_DEPRECATED_ENUMERATOR_IN_4_0_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_0
#define GDK_DEPRECATED_TYPE_IN_4_0_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_0
#define GDK_AVAILABLE_IN_4_0 GDK_UNAVAILABLE (4, 0)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_0 GDK_UNAVAILABLE_STATIC_INLINE (4, 0)
#define GDK_AVAILABLE_MACRO_IN_4_0 GDK_UNAVAILABLE_MACRO (4, 0)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_0 GDK_UNAVAILABLE_ENUMERATOR (4, 0)
#define GDK_AVAILABLE_TYPE_IN_4_0 GDK_UNAVAILABLE_TYPE (4, 0)
#else
#define GDK_AVAILABLE_IN_4_0 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_0
#define GDK_AVAILABLE_MACRO_IN_4_0
#define GDK_AVAILABLE_ENUMERATOR_IN_4_0
#define GDK_AVAILABLE_TYPE_IN_4_0
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_2
#define GDK_DEPRECATED_IN_4_2 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_2_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_2 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_2_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_2 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_2_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_2 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_2_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_2 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_2_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_2
#define GDK_DEPRECATED_MACRO_IN_4_2_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_2
#define GDK_DEPRECATED_ENUMERATOR_IN_4_2_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_2
#define GDK_DEPRECATED_TYPE_IN_4_2_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_2
#define GDK_AVAILABLE_IN_4_2 GDK_UNAVAILABLE (4, 2)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_2 GDK_UNAVAILABLE_STATIC_INLINE (4, 2)
#define GDK_AVAILABLE_MACRO_IN_4_2 GDK_UNAVAILABLE_MACRO (4, 2)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_2 GDK_UNAVAILABLE_ENUMERATOR (4, 2)
#define GDK_AVAILABLE_TYPE_IN_4_2 GDK_UNAVAILABLE_TYPE (4, 2)
#else
#define GDK_AVAILABLE_IN_4_2 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_2
#define GDK_AVAILABLE_MACRO_IN_4_2
#define GDK_AVAILABLE_ENUMERATOR_IN_4_2
#define GDK_AVAILABLE_TYPE_IN_4_2
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_4
#define GDK_DEPRECATED_IN_4_4 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_4_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_4 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_4_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_4 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_4_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_4 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_4_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_4 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_4_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_4
#define GDK_DEPRECATED_MACRO_IN_4_4_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_4
#define GDK_DEPRECATED_ENUMERATOR_IN_4_4_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_4
#define GDK_DEPRECATED_TYPE_IN_4_4_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_4
#define GDK_AVAILABLE_IN_4_4 GDK_UNAVAILABLE (4, 4)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_4 GDK_UNAVAILABLE_STATIC_INLINE (4, 4)
#define GDK_AVAILABLE_MACRO_IN_4_4 GDK_UNAVAILABLE_MACRO (4, 4)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_4 GDK_UNAVAILABLE_ENUMERATOR (4, 4)
#define GDK_AVAILABLE_TYPE_IN_4_4 GDK_UNAVAILABLE_TYPE (4, 4)
#else
#define GDK_AVAILABLE_IN_4_4 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_4
#define GDK_AVAILABLE_MACRO_IN_4_4
#define GDK_AVAILABLE_ENUMERATOR_IN_4_4
#define GDK_AVAILABLE_TYPE_IN_4_4
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_6
#define GDK_DEPRECATED_IN_4_6 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_6_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_6 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_6_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_6 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_6_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_6 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_6_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_6 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_6_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_6
#define GDK_DEPRECATED_MACRO_IN_4_6_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_6
#define GDK_DEPRECATED_ENUMERATOR_IN_4_6_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_6
#define GDK_DEPRECATED_TYPE_IN_4_6_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_6
#define GDK_AVAILABLE_IN_4_6 GDK_UNAVAILABLE (4, 6)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_6 GDK_UNAVAILABLE_STATIC_INLINE (4, 6)
#define GDK_AVAILABLE_MACRO_IN_4_6 GDK_UNAVAILABLE_MACRO (4, 6)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_6 GDK_UNAVAILABLE_ENUMERATOR (4, 6)
#define GDK_AVAILABLE_TYPE_IN_4_6 GDK_UNAVAILABLE_TYPE (4, 6)
#else
#define GDK_AVAILABLE_IN_4_6 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_6
#define GDK_AVAILABLE_MACRO_IN_4_6
#define GDK_AVAILABLE_ENUMERATOR_IN_4_6
#define GDK_AVAILABLE_TYPE_IN_4_6
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_8
#define GDK_DEPRECATED_IN_4_8 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_8_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_8 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_8_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_8 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_8_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_8 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_8_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_8 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_8_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_8
#define GDK_DEPRECATED_MACRO_IN_4_8_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_8
#define GDK_DEPRECATED_ENUMERATOR_IN_4_8_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_8
#define GDK_DEPRECATED_TYPE_IN_4_8_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_8
#define GDK_AVAILABLE_IN_4_8 GDK_UNAVAILABLE (4, 8)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_8 GDK_UNAVAILABLE_STATIC_INLINE (4, 8)
#define GDK_AVAILABLE_MACRO_IN_4_8 GDK_UNAVAILABLE_MACRO (4, 8)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_8 GDK_UNAVAILABLE_ENUMERATOR (4, 8)
#define GDK_AVAILABLE_TYPE_IN_4_8 GDK_UNAVAILABLE_TYPE (4, 8)
#else
#define GDK_AVAILABLE_IN_4_8 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_8
#define GDK_AVAILABLE_MACRO_IN_4_8
#define GDK_AVAILABLE_ENUMERATOR_IN_4_8
#define GDK_AVAILABLE_TYPE_IN_4_8
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_10
#define GDK_DEPRECATED_IN_4_10 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_10_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_10 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_10_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_10 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_10_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_10 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_10_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_10 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_10_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_10
#define GDK_DEPRECATED_MACRO_IN_4_10_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_10
#define GDK_DEPRECATED_ENUMERATOR_IN_4_10_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_10
#define GDK_DEPRECATED_TYPE_IN_4_10_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_10
#define GDK_AVAILABLE_IN_4_10 GDK_UNAVAILABLE (4, 10)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_10 GDK_UNAVAILABLE_STATIC_INLINE (4, 10)
#define GDK_AVAILABLE_MACRO_IN_4_10 GDK_UNAVAILABLE_MACRO (4, 10)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_10 GDK_UNAVAILABLE_ENUMERATOR (4, 10)
#define GDK_AVAILABLE_TYPE_IN_4_10 GDK_UNAVAILABLE_TYPE (4, 10)
#else
#define GDK_AVAILABLE_IN_4_10 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_10
#define GDK_AVAILABLE_MACRO_IN_4_10
#define GDK_AVAILABLE_ENUMERATOR_IN_4_10
#define GDK_AVAILABLE_TYPE_IN_4_10
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_12
#define GDK_DEPRECATED_IN_4_12 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_12_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_12 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_12_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_12 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_12_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_12 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_12_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_12 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_12_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_12
#define GDK_DEPRECATED_MACRO_IN_4_12_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_12
#define GDK_DEPRECATED_ENUMERATOR_IN_4_12_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_12
#define GDK_DEPRECATED_TYPE_IN_4_12_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_12
#define GDK_AVAILABLE_IN_4_12 GDK_UNAVAILABLE (4, 12)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_12 GDK_UNAVAILABLE_STATIC_INLINE (4, 12)
#define GDK_AVAILABLE_MACRO_IN_4_12 GDK_UNAVAILABLE_MACRO (4, 12)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_12 GDK_UNAVAILABLE_ENUMERATOR (4, 12)
#define GDK_AVAILABLE_TYPE_IN_4_12 GDK_UNAVAILABLE_TYPE (4, 12)
#else
#define GDK_AVAILABLE_IN_4_12 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_12
#define GDK_AVAILABLE_MACRO_IN_4_12
#define GDK_AVAILABLE_ENUMERATOR_IN_4_12
#define GDK_AVAILABLE_TYPE_IN_4_12
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_14
#define GDK_DEPRECATED_IN_4_14 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_14_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_14 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_14_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_14 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_14_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_14 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_14_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_14 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_14_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_14
#define GDK_DEPRECATED_MACRO_IN_4_14_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_14
#define GDK_DEPRECATED_ENUMERATOR_IN_4_14_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_14
#define GDK_DEPRECATED_TYPE_IN_4_14_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_14
#define GDK_AVAILABLE_IN_4_14 GDK_UNAVAILABLE (4, 14)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_14 GDK_UNAVAILABLE_STATIC_INLINE (4, 14)
#define GDK_AVAILABLE_MACRO_IN_4_14 GDK_UNAVAILABLE_MACRO (4, 14)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_14 GDK_UNAVAILABLE_ENUMERATOR (4, 14)
#define GDK_AVAILABLE_TYPE_IN_4_14 GDK_UNAVAILABLE_TYPE (4, 14)
#else
#define GDK_AVAILABLE_IN_4_14 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_14
#define GDK_AVAILABLE_MACRO_IN_4_14
#define GDK_AVAILABLE_ENUMERATOR_IN_4_14
#define GDK_AVAILABLE_TYPE_IN_4_14
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_16
#define GDK_DEPRECATED_IN_4_16 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_16_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_16 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_16_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_16 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_16_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_16 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_16_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_16 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_16_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_16
#define GDK_DEPRECATED_MACRO_IN_4_16_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_16
#define GDK_DEPRECATED_ENUMERATOR_IN_4_16_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_16
#define GDK_DEPRECATED_TYPE_IN_4_16_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_16
#define GDK_AVAILABLE_IN_4_16 GDK_UNAVAILABLE (4, 16)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_16 GDK_UNAVAILABLE_STATIC_INLINE (4, 16)
#define GDK_AVAILABLE_MACRO_IN_4_16 GDK_UNAVAILABLE_MACRO (4, 16)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_16 GDK_UNAVAILABLE_ENUMERATOR (4, 16)
#define GDK_AVAILABLE_TYPE_IN_4_16 GDK_UNAVAILABLE_TYPE (4, 16)
#else
#define GDK_AVAILABLE_IN_4_16 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_16
#define GDK_AVAILABLE_MACRO_IN_4_16
#define GDK_AVAILABLE_ENUMERATOR_IN_4_16
#define GDK_AVAILABLE_TYPE_IN_4_16
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_18
#define GDK_DEPRECATED_IN_4_18 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_18_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_18 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_18_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_18 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_18_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_18 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_18_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_18 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_18_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_18
#define GDK_DEPRECATED_MACRO_IN_4_18_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_18
#define GDK_DEPRECATED_ENUMERATOR_IN_4_18_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_18
#define GDK_DEPRECATED_TYPE_IN_4_18_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_18
#define GDK_AVAILABLE_IN_4_18 GDK_UNAVAILABLE (4, 18)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_18 GDK_UNAVAILABLE_STATIC_INLINE (4, 18)
#define GDK_AVAILABLE_MACRO_IN_4_18 GDK_UNAVAILABLE_MACRO (4, 18)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_18 GDK_UNAVAILABLE_ENUMERATOR (4, 18)
#define GDK_AVAILABLE_TYPE_IN_4_18 GDK_UNAVAILABLE_TYPE (4, 18)
#else
#define GDK_AVAILABLE_IN_4_18 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_18
#define GDK_AVAILABLE_MACRO_IN_4_18
#define GDK_AVAILABLE_ENUMERATOR_IN_4_18
#define GDK_AVAILABLE_TYPE_IN_4_18
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_20
#define GDK_DEPRECATED_IN_4_20 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_20_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_20 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_20_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_20 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_20_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_20 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_20_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_20 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_20_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_20
#define GDK_DEPRECATED_MACRO_IN_4_20_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_20
#define GDK_DEPRECATED_ENUMERATOR_IN_4_20_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_20
#define GDK_DEPRECATED_TYPE_IN_4_20_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_20
#define GDK_AVAILABLE_IN_4_20 GDK_UNAVAILABLE (4, 20)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_20 GDK_UNAVAILABLE_STATIC_INLINE (4, 20)
#define GDK_AVAILABLE_MACRO_IN_4_20 GDK_UNAVAILABLE_MACRO (4, 20)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_20 GDK_UNAVAILABLE_ENUMERATOR (4, 20)
#define GDK_AVAILABLE_TYPE_IN_4_20 GDK_UNAVAILABLE_TYPE (4, 20)
#else
#define GDK_AVAILABLE_IN_4_20 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_20
#define GDK_AVAILABLE_MACRO_IN_4_20
#define GDK_AVAILABLE_ENUMERATOR_IN_4_20
#define GDK_AVAILABLE_TYPE_IN_4_20
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_22
#define GDK_DEPRECATED_IN_4_22 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_22_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_22 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_22_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_22 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_22_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_22 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_22_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_22 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_22_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_22
#define GDK_DEPRECATED_MACRO_IN_4_22_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_22
#define GDK_DEPRECATED_ENUMERATOR_IN_4_22_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_22
#define GDK_DEPRECATED_TYPE_IN_4_22_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_22
#define GDK_AVAILABLE_IN_4_22 GDK_UNAVAILABLE (4, 22)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_22 GDK_UNAVAILABLE_STATIC_INLINE (4, 22)
#define GDK_AVAILABLE_MACRO_IN_4_22 GDK_UNAVAILABLE_MACRO (4, 22)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_22 GDK_UNAVAILABLE_ENUMERATOR (4, 22)
#define GDK_AVAILABLE_TYPE_IN_4_22 GDK_UNAVAILABLE_TYPE (4, 22)
#else
#define GDK_AVAILABLE_IN_4_22 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_22
#define GDK_AVAILABLE_MACRO_IN_4_22
#define GDK_AVAILABLE_ENUMERATOR_IN_4_22
#define GDK_AVAILABLE_TYPE_IN_4_22
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_24
#define GDK_DEPRECATED_IN_4_24 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_24_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_24 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_24_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_24 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_24_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_24 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_24_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_24 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_24_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_24
#define GDK_DEPRECATED_MACRO_IN_4_24_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_24
#define GDK_DEPRECATED_ENUMERATOR_IN_4_24_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_24
#define GDK_DEPRECATED_TYPE_IN_4_24_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_24
#define GDK_AVAILABLE_IN_4_24 GDK_UNAVAILABLE (4, 24)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_24 GDK_UNAVAILABLE_STATIC_INLINE (4, 24)
#define GDK_AVAILABLE_MACRO_IN_4_24 GDK_UNAVAILABLE_MACRO (4, 24)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_24 GDK_UNAVAILABLE_ENUMERATOR (4, 24)
#define GDK_AVAILABLE_TYPE_IN_4_24 GDK_UNAVAILABLE_TYPE (4, 24)
#else
#define GDK_AVAILABLE_IN_4_24 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_24
#define GDK_AVAILABLE_MACRO_IN_4_24
#define GDK_AVAILABLE_ENUMERATOR_IN_4_24
#define GDK_AVAILABLE_TYPE_IN_4_24
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_26
#define GDK_DEPRECATED_IN_4_26 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_26_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_26 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_26_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_26 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_26_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_26 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_26_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_26 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_26_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_26
#define GDK_DEPRECATED_MACRO_IN_4_26_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_26
#define GDK_DEPRECATED_ENUMERATOR_IN_4_26_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_26
#define GDK_DEPRECATED_TYPE_IN_4_26_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_26
#define GDK_AVAILABLE_IN_4_26 GDK_UNAVAILABLE (4, 26)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_26 GDK_UNAVAILABLE_STATIC_INLINE (4, 26)
#define GDK_AVAILABLE_MACRO_IN_4_26 GDK_UNAVAILABLE_MACRO (4, 26)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_26 GDK_UNAVAILABLE_ENUMERATOR (4, 26)
#define GDK_AVAILABLE_TYPE_IN_4_26 GDK_UNAVAILABLE_TYPE (4, 26)
#else
#define GDK_AVAILABLE_IN_4_26 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_26
#define GDK_AVAILABLE_MACRO_IN_4_26
#define GDK_AVAILABLE_ENUMERATOR_IN_4_26
#define GDK_AVAILABLE_TYPE_IN_4_26
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_28
#define GDK_DEPRECATED_IN_4_28 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_28_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_28 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_28_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_28 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_28_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_28 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_28_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_28 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_28_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_28
#define GDK_DEPRECATED_MACRO_IN_4_28_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_28
#define GDK_DEPRECATED_ENUMERATOR_IN_4_28_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_28
#define GDK_DEPRECATED_TYPE_IN_4_28_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_28
#define GDK_AVAILABLE_IN_4_28 GDK_UNAVAILABLE (4, 28)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_28 GDK_UNAVAILABLE_STATIC_INLINE (4, 28)
#define GDK_AVAILABLE_MACRO_IN_4_28 GDK_UNAVAILABLE_MACRO (4, 28)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_28 GDK_UNAVAILABLE_ENUMERATOR (4, 28)
#define GDK_AVAILABLE_TYPE_IN_4_28 GDK_UNAVAILABLE_TYPE (4, 28)
#else
#define GDK_AVAILABLE_IN_4_28 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_28
#define GDK_AVAILABLE_MACRO_IN_4_28
#define GDK_AVAILABLE_ENUMERATOR_IN_4_28
#define GDK_AVAILABLE_TYPE_IN_4_28
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_30
#define GDK_DEPRECATED_IN_4_30 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_30_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_30 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_30_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_30 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_30_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_30 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_30_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_30 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_30_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_30
#define GDK_DEPRECATED_MACRO_IN_4_30_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_30
#define GDK_DEPRECATED_ENUMERATOR_IN_4_30_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_30
#define GDK_DEPRECATED_TYPE_IN_4_30_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_30
#define GDK_AVAILABLE_IN_4_30 GDK_UNAVAILABLE (4, 30)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_30 GDK_UNAVAILABLE_STATIC_INLINE (4, 30)
#define GDK_AVAILABLE_MACRO_IN_4_30 GDK_UNAVAILABLE_MACRO (4, 30)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_30 GDK_UNAVAILABLE_ENUMERATOR (4, 30)
#define GDK_AVAILABLE_TYPE_IN_4_30 GDK_UNAVAILABLE_TYPE (4, 30)
#else
#define GDK_AVAILABLE_IN_4_30 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_30
#define GDK_AVAILABLE_MACRO_IN_4_30
#define GDK_AVAILABLE_ENUMERATOR_IN_4_30
#define GDK_AVAILABLE_TYPE_IN_4_30
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_32
#define GDK_DEPRECATED_IN_4_32 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_32_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_32 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_32_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_32 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_32_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_32 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_32_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_32 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_32_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_32
#define GDK_DEPRECATED_MACRO_IN_4_32_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_32
#define GDK_DEPRECATED_ENUMERATOR_IN_4_32_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_32
#define GDK_DEPRECATED_TYPE_IN_4_32_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_32
#define GDK_AVAILABLE_IN_4_32 GDK_UNAVAILABLE (4, 32)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_32 GDK_UNAVAILABLE_STATIC_INLINE (4, 32)
#define GDK_AVAILABLE_MACRO_IN_4_32 GDK_UNAVAILABLE_MACRO (4, 32)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_32 GDK_UNAVAILABLE_ENUMERATOR (4, 32)
#define GDK_AVAILABLE_TYPE_IN_4_32 GDK_UNAVAILABLE_TYPE (4, 32)
#else
#define GDK_AVAILABLE_IN_4_32 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_32
#define GDK_AVAILABLE_MACRO_IN_4_32
#define GDK_AVAILABLE_ENUMERATOR_IN_4_32
#define GDK_AVAILABLE_TYPE_IN_4_32
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_34
#define GDK_DEPRECATED_IN_4_34 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_34_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_34 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_34_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_34 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_34_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_34 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_34_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_34 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_34_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_34
#define GDK_DEPRECATED_MACRO_IN_4_34_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_34
#define GDK_DEPRECATED_ENUMERATOR_IN_4_34_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_34
#define GDK_DEPRECATED_TYPE_IN_4_34_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_34
#define GDK_AVAILABLE_IN_4_34 GDK_UNAVAILABLE (4, 34)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_34 GDK_UNAVAILABLE_STATIC_INLINE (4, 34)
#define GDK_AVAILABLE_MACRO_IN_4_34 GDK_UNAVAILABLE_MACRO (4, 34)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_34 GDK_UNAVAILABLE_ENUMERATOR (4, 34)
#define GDK_AVAILABLE_TYPE_IN_4_34 GDK_UNAVAILABLE_TYPE (4, 34)
#else
#define GDK_AVAILABLE_IN_4_34 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_34
#define GDK_AVAILABLE_MACRO_IN_4_34
#define GDK_AVAILABLE_ENUMERATOR_IN_4_34
#define GDK_AVAILABLE_TYPE_IN_4_34
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_36
#define GDK_DEPRECATED_IN_4_36 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_36_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_36 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_36_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_36 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_36_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_36 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_36_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_36 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_36_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_36
#define GDK_DEPRECATED_MACRO_IN_4_36_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_36
#define GDK_DEPRECATED_ENUMERATOR_IN_4_36_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_36
#define GDK_DEPRECATED_TYPE_IN_4_36_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_36
#define GDK_AVAILABLE_IN_4_36 GDK_UNAVAILABLE (4, 36)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_36 GDK_UNAVAILABLE_STATIC_INLINE (4, 36)
#define GDK_AVAILABLE_MACRO_IN_4_36 GDK_UNAVAILABLE_MACRO (4, 36)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_36 GDK_UNAVAILABLE_ENUMERATOR (4, 36)
#define GDK_AVAILABLE_TYPE_IN_4_36 GDK_UNAVAILABLE_TYPE (4, 36)
#else
#define GDK_AVAILABLE_IN_4_36 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_36
#define GDK_AVAILABLE_MACRO_IN_4_36
#define GDK_AVAILABLE_ENUMERATOR_IN_4_36
#define GDK_AVAILABLE_TYPE_IN_4_36
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_38
#define GDK_DEPRECATED_IN_4_38 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_38_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_38 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_38_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_38 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_38_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_38 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_38_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_38 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_38_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_38
#define GDK_DEPRECATED_MACRO_IN_4_38_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_38
#define GDK_DEPRECATED_ENUMERATOR_IN_4_38_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_38
#define GDK_DEPRECATED_TYPE_IN_4_38_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_38
#define GDK_AVAILABLE_IN_4_38 GDK_UNAVAILABLE (4, 38)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_38 GDK_UNAVAILABLE_STATIC_INLINE (4, 38)
#define GDK_AVAILABLE_MACRO_IN_4_38 GDK_UNAVAILABLE_MACRO (4, 38)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_38 GDK_UNAVAILABLE_ENUMERATOR (4, 38)
#define GDK_AVAILABLE_TYPE_IN_4_38 GDK_UNAVAILABLE_TYPE (4, 38)
#else
#define GDK_AVAILABLE_IN_4_38 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_38
#define GDK_AVAILABLE_MACRO_IN_4_38
#define GDK_AVAILABLE_ENUMERATOR_IN_4_38
#define GDK_AVAILABLE_TYPE_IN_4_38
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_40
#define GDK_DEPRECATED_IN_4_40 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_40_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_40 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_40_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_40 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_40_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_40 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_40_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_40 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_40_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_40
#define GDK_DEPRECATED_MACRO_IN_4_40_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_40
#define GDK_DEPRECATED_ENUMERATOR_IN_4_40_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_40
#define GDK_DEPRECATED_TYPE_IN_4_40_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_40
#define GDK_AVAILABLE_IN_4_40 GDK_UNAVAILABLE (4, 40)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_40 GDK_UNAVAILABLE_STATIC_INLINE (4, 40)
#define GDK_AVAILABLE_MACRO_IN_4_40 GDK_UNAVAILABLE_MACRO (4, 40)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_40 GDK_UNAVAILABLE_ENUMERATOR (4, 40)
#define GDK_AVAILABLE_TYPE_IN_4_40 GDK_UNAVAILABLE_TYPE (4, 40)
#else
#define GDK_AVAILABLE_IN_4_40 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_40
#define GDK_AVAILABLE_MACRO_IN_4_40
#define GDK_AVAILABLE_ENUMERATOR_IN_4_40
#define GDK_AVAILABLE_TYPE_IN_4_40
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_42
#define GDK_DEPRECATED_IN_4_42 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_42_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_42 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_42_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_42 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_42_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_42 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_42_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_42 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_42_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_42
#define GDK_DEPRECATED_MACRO_IN_4_42_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_42
#define GDK_DEPRECATED_ENUMERATOR_IN_4_42_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_42
#define GDK_DEPRECATED_TYPE_IN_4_42_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_42
#define GDK_AVAILABLE_IN_4_42 GDK_UNAVAILABLE (4, 42)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_42 GDK_UNAVAILABLE_STATIC_INLINE (4, 42)
#define GDK_AVAILABLE_MACRO_IN_4_42 GDK_UNAVAILABLE_MACRO (4, 42)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_42 GDK_UNAVAILABLE_ENUMERATOR (4, 42)
#define GDK_AVAILABLE_TYPE_IN_4_42 GDK_UNAVAILABLE_TYPE (4, 42)
#else
#define GDK_AVAILABLE_IN_4_42 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_42
#define GDK_AVAILABLE_MACRO_IN_4_42
#define GDK_AVAILABLE_ENUMERATOR_IN_4_42
#define GDK_AVAILABLE_TYPE_IN_4_42
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_44
#define GDK_DEPRECATED_IN_4_44 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_44_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_44 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_44_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_44 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_44_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_44 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_44_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_44 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_44_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_44
#define GDK_DEPRECATED_MACRO_IN_4_44_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_44
#define GDK_DEPRECATED_ENUMERATOR_IN_4_44_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_44
#define GDK_DEPRECATED_TYPE_IN_4_44_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_44
#define GDK_AVAILABLE_IN_4_44 GDK_UNAVAILABLE (4, 44)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_44 GDK_UNAVAILABLE_STATIC_INLINE (4, 44)
#define GDK_AVAILABLE_MACRO_IN_4_44 GDK_UNAVAILABLE_MACRO (4, 44)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_44 GDK_UNAVAILABLE_ENUMERATOR (4, 44)
#define GDK_AVAILABLE_TYPE_IN_4_44 GDK_UNAVAILABLE_TYPE (4, 44)
#else
#define GDK_AVAILABLE_IN_4_44 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_44
#define GDK_AVAILABLE_MACRO_IN_4_44
#define GDK_AVAILABLE_ENUMERATOR_IN_4_44
#define GDK_AVAILABLE_TYPE_IN_4_44
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_46
#define GDK_DEPRECATED_IN_4_46 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_46_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_46 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_46_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_46 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_46_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_46 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_46_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_46 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_46_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_46
#define GDK_DEPRECATED_MACRO_IN_4_46_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_46
#define GDK_DEPRECATED_ENUMERATOR_IN_4_46_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_46
#define GDK_DEPRECATED_TYPE_IN_4_46_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_46
#define GDK_AVAILABLE_IN_4_46 GDK_UNAVAILABLE (4, 46)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_46 GDK_UNAVAILABLE_STATIC_INLINE (4, 46)
#define GDK_AVAILABLE_MACRO_IN_4_46 GDK_UNAVAILABLE_MACRO (4, 46)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_46 GDK_UNAVAILABLE_ENUMERATOR (4, 46)
#define GDK_AVAILABLE_TYPE_IN_4_46 GDK_UNAVAILABLE_TYPE (4, 46)
#else
#define GDK_AVAILABLE_IN_4_46 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_46
#define GDK_AVAILABLE_MACRO_IN_4_46
#define GDK_AVAILABLE_ENUMERATOR_IN_4_46
#define GDK_AVAILABLE_TYPE_IN_4_46
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_48
#define GDK_DEPRECATED_IN_4_48 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_48_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_48 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_48_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_48 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_48_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_48 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_48_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_48 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_48_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_48
#define GDK_DEPRECATED_MACRO_IN_4_48_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_48
#define GDK_DEPRECATED_ENUMERATOR_IN_4_48_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_48
#define GDK_DEPRECATED_TYPE_IN_4_48_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_48
#define GDK_AVAILABLE_IN_4_48 GDK_UNAVAILABLE (4, 48)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_48 GDK_UNAVAILABLE_STATIC_INLINE (4, 48)
#define GDK_AVAILABLE_MACRO_IN_4_48 GDK_UNAVAILABLE_MACRO (4, 48)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_48 GDK_UNAVAILABLE_ENUMERATOR (4, 48)
#define GDK_AVAILABLE_TYPE_IN_4_48 GDK_UNAVAILABLE_TYPE (4, 48)
#else
#define GDK_AVAILABLE_IN_4_48 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_48
#define GDK_AVAILABLE_MACRO_IN_4_48
#define GDK_AVAILABLE_ENUMERATOR_IN_4_48
#define GDK_AVAILABLE_TYPE_IN_4_48
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_50
#define GDK_DEPRECATED_IN_4_50 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_50_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_50 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_50_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_50 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_50_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_50 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_50_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_50 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_50_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_50
#define GDK_DEPRECATED_MACRO_IN_4_50_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_50
#define GDK_DEPRECATED_ENUMERATOR_IN_4_50_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_50
#define GDK_DEPRECATED_TYPE_IN_4_50_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_50
#define GDK_AVAILABLE_IN_4_50 GDK_UNAVAILABLE (4, 50)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_50 GDK_UNAVAILABLE_STATIC_INLINE (4, 50)
#define GDK_AVAILABLE_MACRO_IN_4_50 GDK_UNAVAILABLE_MACRO (4, 50)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_50 GDK_UNAVAILABLE_ENUMERATOR (4, 50)
#define GDK_AVAILABLE_TYPE_IN_4_50 GDK_UNAVAILABLE_TYPE (4, 50)
#else
#define GDK_AVAILABLE_IN_4_50 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_50
#define GDK_AVAILABLE_MACRO_IN_4_50
#define GDK_AVAILABLE_ENUMERATOR_IN_4_50
#define GDK_AVAILABLE_TYPE_IN_4_50
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_52
#define GDK_DEPRECATED_IN_4_52 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_52_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_52 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_52_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_52 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_52_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_52 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_52_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_52 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_52_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_52
#define GDK_DEPRECATED_MACRO_IN_4_52_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_52
#define GDK_DEPRECATED_ENUMERATOR_IN_4_52_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_52
#define GDK_DEPRECATED_TYPE_IN_4_52_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_52
#define GDK_AVAILABLE_IN_4_52 GDK_UNAVAILABLE (4, 52)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_52 GDK_UNAVAILABLE_STATIC_INLINE (4, 52)
#define GDK_AVAILABLE_MACRO_IN_4_52 GDK_UNAVAILABLE_MACRO (4, 52)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_52 GDK_UNAVAILABLE_ENUMERATOR (4, 52)
#define GDK_AVAILABLE_TYPE_IN_4_52 GDK_UNAVAILABLE_TYPE (4, 52)
#else
#define GDK_AVAILABLE_IN_4_52 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_52
#define GDK_AVAILABLE_MACRO_IN_4_52
#define GDK_AVAILABLE_ENUMERATOR_IN_4_52
#define GDK_AVAILABLE_TYPE_IN_4_52
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_54
#define GDK_DEPRECATED_IN_4_54 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_54_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_54 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_54_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_54 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_54_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_54 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_54_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_54 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_54_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_54
#define GDK_DEPRECATED_MACRO_IN_4_54_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_54
#define GDK_DEPRECATED_ENUMERATOR_IN_4_54_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_54
#define GDK_DEPRECATED_TYPE_IN_4_54_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_54
#define GDK_AVAILABLE_IN_4_54 GDK_UNAVAILABLE (4, 54)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_54 GDK_UNAVAILABLE_STATIC_INLINE (4, 54)
#define GDK_AVAILABLE_MACRO_IN_4_54 GDK_UNAVAILABLE_MACRO (4, 54)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_54 GDK_UNAVAILABLE_ENUMERATOR (4, 54)
#define GDK_AVAILABLE_TYPE_IN_4_54 GDK_UNAVAILABLE_TYPE (4, 54)
#else
#define GDK_AVAILABLE_IN_4_54 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_54
#define GDK_AVAILABLE_MACRO_IN_4_54
#define GDK_AVAILABLE_ENUMERATOR_IN_4_54
#define GDK_AVAILABLE_TYPE_IN_4_54
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_56
#define GDK_DEPRECATED_IN_4_56 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_56_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_56 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_56_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_56 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_56_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_56 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_56_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_56 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_56_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_56
#define GDK_DEPRECATED_MACRO_IN_4_56_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_56
#define GDK_DEPRECATED_ENUMERATOR_IN_4_56_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_56
#define GDK_DEPRECATED_TYPE_IN_4_56_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_56
#define GDK_AVAILABLE_IN_4_56 GDK_UNAVAILABLE (4, 56)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_56 GDK_UNAVAILABLE_STATIC_INLINE (4, 56)
#define GDK_AVAILABLE_MACRO_IN_4_56 GDK_UNAVAILABLE_MACRO (4, 56)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_56 GDK_UNAVAILABLE_ENUMERATOR (4, 56)
#define GDK_AVAILABLE_TYPE_IN_4_56 GDK_UNAVAILABLE_TYPE (4, 56)
#else
#define GDK_AVAILABLE_IN_4_56 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_56
#define GDK_AVAILABLE_MACRO_IN_4_56
#define GDK_AVAILABLE_ENUMERATOR_IN_4_56
#define GDK_AVAILABLE_TYPE_IN_4_56
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_58
#define GDK_DEPRECATED_IN_4_58 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_58_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_58 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_58_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_58 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_58_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_58 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_58_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_58 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_58_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_58
#define GDK_DEPRECATED_MACRO_IN_4_58_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_58
#define GDK_DEPRECATED_ENUMERATOR_IN_4_58_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_58
#define GDK_DEPRECATED_TYPE_IN_4_58_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_58
#define GDK_AVAILABLE_IN_4_58 GDK_UNAVAILABLE (4, 58)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_58 GDK_UNAVAILABLE_STATIC_INLINE (4, 58)
#define GDK_AVAILABLE_MACRO_IN_4_58 GDK_UNAVAILABLE_MACRO (4, 58)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_58 GDK_UNAVAILABLE_ENUMERATOR (4, 58)
#define GDK_AVAILABLE_TYPE_IN_4_58 GDK_UNAVAILABLE_TYPE (4, 58)
#else
#define GDK_AVAILABLE_IN_4_58 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_58
#define GDK_AVAILABLE_MACRO_IN_4_58
#define GDK_AVAILABLE_ENUMERATOR_IN_4_58
#define GDK_AVAILABLE_TYPE_IN_4_58
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_60
#define GDK_DEPRECATED_IN_4_60 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_60_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_60 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_60_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_60 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_60_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_60 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_60_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_60 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_60_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_60
#define GDK_DEPRECATED_MACRO_IN_4_60_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_60
#define GDK_DEPRECATED_ENUMERATOR_IN_4_60_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_60
#define GDK_DEPRECATED_TYPE_IN_4_60_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_60
#define GDK_AVAILABLE_IN_4_60 GDK_UNAVAILABLE (4, 60)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_60 GDK_UNAVAILABLE_STATIC_INLINE (4, 60)
#define GDK_AVAILABLE_MACRO_IN_4_60 GDK_UNAVAILABLE_MACRO (4, 60)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_60 GDK_UNAVAILABLE_ENUMERATOR (4, 60)
#define GDK_AVAILABLE_TYPE_IN_4_60 GDK_UNAVAILABLE_TYPE (4, 60)
#else
#define GDK_AVAILABLE_IN_4_60 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_60
#define GDK_AVAILABLE_MACRO_IN_4_60
#define GDK_AVAILABLE_ENUMERATOR_IN_4_60
#define GDK_AVAILABLE_TYPE_IN_4_60
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_62
#define GDK_DEPRECATED_IN_4_62 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_62_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_62 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_62_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_62 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_62_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_62 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_62_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_62 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_62_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_62
#define GDK_DEPRECATED_MACRO_IN_4_62_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_62
#define GDK_DEPRECATED_ENUMERATOR_IN_4_62_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_62
#define GDK_DEPRECATED_TYPE_IN_4_62_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_62
#define GDK_AVAILABLE_IN_4_62 GDK_UNAVAILABLE (4, 62)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_62 GDK_UNAVAILABLE_STATIC_INLINE (4, 62)
#define GDK_AVAILABLE_MACRO_IN_4_62 GDK_UNAVAILABLE_MACRO (4, 62)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_62 GDK_UNAVAILABLE_ENUMERATOR (4, 62)
#define GDK_AVAILABLE_TYPE_IN_4_62 GDK_UNAVAILABLE_TYPE (4, 62)
#else
#define GDK_AVAILABLE_IN_4_62 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_62
#define GDK_AVAILABLE_MACRO_IN_4_62
#define GDK_AVAILABLE_ENUMERATOR_IN_4_62
#define GDK_AVAILABLE_TYPE_IN_4_62
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_64
#define GDK_DEPRECATED_IN_4_64 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_64_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_64 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_64_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_64 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_64_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_64 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_64_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_64 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_64_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_64
#define GDK_DEPRECATED_MACRO_IN_4_64_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_64
#define GDK_DEPRECATED_ENUMERATOR_IN_4_64_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_64
#define GDK_DEPRECATED_TYPE_IN_4_64_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_64
#define GDK_AVAILABLE_IN_4_64 GDK_UNAVAILABLE (4, 64)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_64 GDK_UNAVAILABLE_STATIC_INLINE (4, 64)
#define GDK_AVAILABLE_MACRO_IN_4_64 GDK_UNAVAILABLE_MACRO (4, 64)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_64 GDK_UNAVAILABLE_ENUMERATOR (4, 64)
#define GDK_AVAILABLE_TYPE_IN_4_64 GDK_UNAVAILABLE_TYPE (4, 64)
#else
#define GDK_AVAILABLE_IN_4_64 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_64
#define GDK_AVAILABLE_MACRO_IN_4_64
#define GDK_AVAILABLE_ENUMERATOR_IN_4_64
#define GDK_AVAILABLE_TYPE_IN_4_64
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_66
#define GDK_DEPRECATED_IN_4_66 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_66_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_66 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_66_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_66 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_66_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_66 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_66_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_66 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_66_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_66
#define GDK_DEPRECATED_MACRO_IN_4_66_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_66
#define GDK_DEPRECATED_ENUMERATOR_IN_4_66_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_66
#define GDK_DEPRECATED_TYPE_IN_4_66_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_66
#define GDK_AVAILABLE_IN_4_66 GDK_UNAVAILABLE (4, 66)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_66 GDK_UNAVAILABLE_STATIC_INLINE (4, 66)
#define GDK_AVAILABLE_MACRO_IN_4_66 GDK_UNAVAILABLE_MACRO (4, 66)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_66 GDK_UNAVAILABLE_ENUMERATOR (4, 66)
#define GDK_AVAILABLE_TYPE_IN_4_66 GDK_UNAVAILABLE_TYPE (4, 66)
#else
#define GDK_AVAILABLE_IN_4_66 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_66
#define GDK_AVAILABLE_MACRO_IN_4_66
#define GDK_AVAILABLE_ENUMERATOR_IN_4_66
#define GDK_AVAILABLE_TYPE_IN_4_66
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_68
#define GDK_DEPRECATED_IN_4_68 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_68_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_68 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_68_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_68 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_68_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_68 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_68_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_68 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_68_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_68
#define GDK_DEPRECATED_MACRO_IN_4_68_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_68
#define GDK_DEPRECATED_ENUMERATOR_IN_4_68_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_68
#define GDK_DEPRECATED_TYPE_IN_4_68_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_68
#define GDK_AVAILABLE_IN_4_68 GDK_UNAVAILABLE (4, 68)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_68 GDK_UNAVAILABLE_STATIC_INLINE (4, 68)
#define GDK_AVAILABLE_MACRO_IN_4_68 GDK_UNAVAILABLE_MACRO (4, 68)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_68 GDK_UNAVAILABLE_ENUMERATOR (4, 68)
#define GDK_AVAILABLE_TYPE_IN_4_68 GDK_UNAVAILABLE_TYPE (4, 68)
#else
#define GDK_AVAILABLE_IN_4_68 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_68
#define GDK_AVAILABLE_MACRO_IN_4_68
#define GDK_AVAILABLE_ENUMERATOR_IN_4_68
#define GDK_AVAILABLE_TYPE_IN_4_68
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_70
#define GDK_DEPRECATED_IN_4_70 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_70_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_70 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_70_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_70 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_70_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_70 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_70_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_70 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_70_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_70
#define GDK_DEPRECATED_MACRO_IN_4_70_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_70
#define GDK_DEPRECATED_ENUMERATOR_IN_4_70_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_70
#define GDK_DEPRECATED_TYPE_IN_4_70_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_70
#define GDK_AVAILABLE_IN_4_70 GDK_UNAVAILABLE (4, 70)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_70 GDK_UNAVAILABLE_STATIC_INLINE (4, 70)
#define GDK_AVAILABLE_MACRO_IN_4_70 GDK_UNAVAILABLE_MACRO (4, 70)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_70 GDK_UNAVAILABLE_ENUMERATOR (4, 70)
#define GDK_AVAILABLE_TYPE_IN_4_70 GDK_UNAVAILABLE_TYPE (4, 70)
#else
#define GDK_AVAILABLE_IN_4_70 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_70
#define GDK_AVAILABLE_MACRO_IN_4_70
#define GDK_AVAILABLE_ENUMERATOR_IN_4_70
#define GDK_AVAILABLE_TYPE_IN_4_70
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_72
#define GDK_DEPRECATED_IN_4_72 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_72_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_72 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_72_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_72 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_72_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_72 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_72_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_72 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_72_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_72
#define GDK_DEPRECATED_MACRO_IN_4_72_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_72
#define GDK_DEPRECATED_ENUMERATOR_IN_4_72_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_72
#define GDK_DEPRECATED_TYPE_IN_4_72_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_72
#define GDK_AVAILABLE_IN_4_72 GDK_UNAVAILABLE (4, 72)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_72 GDK_UNAVAILABLE_STATIC_INLINE (4, 72)
#define GDK_AVAILABLE_MACRO_IN_4_72 GDK_UNAVAILABLE_MACRO (4, 72)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_72 GDK_UNAVAILABLE_ENUMERATOR (4, 72)
#define GDK_AVAILABLE_TYPE_IN_4_72 GDK_UNAVAILABLE_TYPE (4, 72)
#else
#define GDK_AVAILABLE_IN_4_72 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_72
#define GDK_AVAILABLE_MACRO_IN_4_72
#define GDK_AVAILABLE_ENUMERATOR_IN_4_72
#define GDK_AVAILABLE_TYPE_IN_4_72
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_74
#define GDK_DEPRECATED_IN_4_74 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_74_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_74 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_74_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_74 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_74_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_74 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_74_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_74 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_74_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_74
#define GDK_DEPRECATED_MACRO_IN_4_74_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_74
#define GDK_DEPRECATED_ENUMERATOR_IN_4_74_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_74
#define GDK_DEPRECATED_TYPE_IN_4_74_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_74
#define GDK_AVAILABLE_IN_4_74 GDK_UNAVAILABLE (4, 74)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_74 GDK_UNAVAILABLE_STATIC_INLINE (4, 74)
#define GDK_AVAILABLE_MACRO_IN_4_74 GDK_UNAVAILABLE_MACRO (4, 74)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_74 GDK_UNAVAILABLE_ENUMERATOR (4, 74)
#define GDK_AVAILABLE_TYPE_IN_4_74 GDK_UNAVAILABLE_TYPE (4, 74)
#else
#define GDK_AVAILABLE_IN_4_74 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_74
#define GDK_AVAILABLE_MACRO_IN_4_74
#define GDK_AVAILABLE_ENUMERATOR_IN_4_74
#define GDK_AVAILABLE_TYPE_IN_4_74
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_76
#define GDK_DEPRECATED_IN_4_76 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_76_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_76 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_76_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_76 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_76_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_76 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_76_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_76 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_76_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_76
#define GDK_DEPRECATED_MACRO_IN_4_76_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_76
#define GDK_DEPRECATED_ENUMERATOR_IN_4_76_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_76
#define GDK_DEPRECATED_TYPE_IN_4_76_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_76
#define GDK_AVAILABLE_IN_4_76 GDK_UNAVAILABLE (4, 76)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_76 GDK_UNAVAILABLE_STATIC_INLINE (4, 76)
#define GDK_AVAILABLE_MACRO_IN_4_76 GDK_UNAVAILABLE_MACRO (4, 76)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_76 GDK_UNAVAILABLE_ENUMERATOR (4, 76)
#define GDK_AVAILABLE_TYPE_IN_4_76 GDK_UNAVAILABLE_TYPE (4, 76)
#else
#define GDK_AVAILABLE_IN_4_76 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_76
#define GDK_AVAILABLE_MACRO_IN_4_76
#define GDK_AVAILABLE_ENUMERATOR_IN_4_76
#define GDK_AVAILABLE_TYPE_IN_4_76
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_78
#define GDK_DEPRECATED_IN_4_78 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_78_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_78 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_78_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_78 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_78_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_78 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_78_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_78 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_78_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_78
#define GDK_DEPRECATED_MACRO_IN_4_78_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_78
#define GDK_DEPRECATED_ENUMERATOR_IN_4_78_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_78
#define GDK_DEPRECATED_TYPE_IN_4_78_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_78
#define GDK_AVAILABLE_IN_4_78 GDK_UNAVAILABLE (4, 78)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_78 GDK_UNAVAILABLE_STATIC_INLINE (4, 78)
#define GDK_AVAILABLE_MACRO_IN_4_78 GDK_UNAVAILABLE_MACRO (4, 78)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_78 GDK_UNAVAILABLE_ENUMERATOR (4, 78)
#define GDK_AVAILABLE_TYPE_IN_4_78 GDK_UNAVAILABLE_TYPE (4, 78)
#else
#define GDK_AVAILABLE_IN_4_78 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_78
#define GDK_AVAILABLE_MACRO_IN_4_78
#define GDK_AVAILABLE_ENUMERATOR_IN_4_78
#define GDK_AVAILABLE_TYPE_IN_4_78
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_80
#define GDK_DEPRECATED_IN_4_80 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_80_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_80 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_80_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_80 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_80_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_80 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_80_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_80 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_80_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_80
#define GDK_DEPRECATED_MACRO_IN_4_80_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_80
#define GDK_DEPRECATED_ENUMERATOR_IN_4_80_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_80
#define GDK_DEPRECATED_TYPE_IN_4_80_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_80
#define GDK_AVAILABLE_IN_4_80 GDK_UNAVAILABLE (4, 80)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_80 GDK_UNAVAILABLE_STATIC_INLINE (4, 80)
#define GDK_AVAILABLE_MACRO_IN_4_80 GDK_UNAVAILABLE_MACRO (4, 80)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_80 GDK_UNAVAILABLE_ENUMERATOR (4, 80)
#define GDK_AVAILABLE_TYPE_IN_4_80 GDK_UNAVAILABLE_TYPE (4, 80)
#else
#define GDK_AVAILABLE_IN_4_80 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_80
#define GDK_AVAILABLE_MACRO_IN_4_80
#define GDK_AVAILABLE_ENUMERATOR_IN_4_80
#define GDK_AVAILABLE_TYPE_IN_4_80
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_82
#define GDK_DEPRECATED_IN_4_82 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_82_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_82 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_82_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_82 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_82_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_82 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_82_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_82 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_82_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_82
#define GDK_DEPRECATED_MACRO_IN_4_82_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_82
#define GDK_DEPRECATED_ENUMERATOR_IN_4_82_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_82
#define GDK_DEPRECATED_TYPE_IN_4_82_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_82
#define GDK_AVAILABLE_IN_4_82 GDK_UNAVAILABLE (4, 82)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_82 GDK_UNAVAILABLE_STATIC_INLINE (4, 82)
#define GDK_AVAILABLE_MACRO_IN_4_82 GDK_UNAVAILABLE_MACRO (4, 82)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_82 GDK_UNAVAILABLE_ENUMERATOR (4, 82)
#define GDK_AVAILABLE_TYPE_IN_4_82 GDK_UNAVAILABLE_TYPE (4, 82)
#else
#define GDK_AVAILABLE_IN_4_82 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_82
#define GDK_AVAILABLE_MACRO_IN_4_82
#define GDK_AVAILABLE_ENUMERATOR_IN_4_82
#define GDK_AVAILABLE_TYPE_IN_4_82
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_84
#define GDK_DEPRECATED_IN_4_84 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_84_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_84 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_84_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_84 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_84_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_84 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_84_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_84 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_84_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_84
#define GDK_DEPRECATED_MACRO_IN_4_84_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_84
#define GDK_DEPRECATED_ENUMERATOR_IN_4_84_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_84
#define GDK_DEPRECATED_TYPE_IN_4_84_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_84
#define GDK_AVAILABLE_IN_4_84 GDK_UNAVAILABLE (4, 84)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_84 GDK_UNAVAILABLE_STATIC_INLINE (4, 84)
#define GDK_AVAILABLE_MACRO_IN_4_84 GDK_UNAVAILABLE_MACRO (4, 84)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_84 GDK_UNAVAILABLE_ENUMERATOR (4, 84)
#define GDK_AVAILABLE_TYPE_IN_4_84 GDK_UNAVAILABLE_TYPE (4, 84)
#else
#define GDK_AVAILABLE_IN_4_84 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_84
#define GDK_AVAILABLE_MACRO_IN_4_84
#define GDK_AVAILABLE_ENUMERATOR_IN_4_84
#define GDK_AVAILABLE_TYPE_IN_4_84
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_86
#define GDK_DEPRECATED_IN_4_86 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_86_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_86 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_86_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_86 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_86_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_86 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_86_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_86 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_86_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_86
#define GDK_DEPRECATED_MACRO_IN_4_86_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_86
#define GDK_DEPRECATED_ENUMERATOR_IN_4_86_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_86
#define GDK_DEPRECATED_TYPE_IN_4_86_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_86
#define GDK_AVAILABLE_IN_4_86 GDK_UNAVAILABLE (4, 86)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_86 GDK_UNAVAILABLE_STATIC_INLINE (4, 86)
#define GDK_AVAILABLE_MACRO_IN_4_86 GDK_UNAVAILABLE_MACRO (4, 86)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_86 GDK_UNAVAILABLE_ENUMERATOR (4, 86)
#define GDK_AVAILABLE_TYPE_IN_4_86 GDK_UNAVAILABLE_TYPE (4, 86)
#else
#define GDK_AVAILABLE_IN_4_86 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_86
#define GDK_AVAILABLE_MACRO_IN_4_86
#define GDK_AVAILABLE_ENUMERATOR_IN_4_86
#define GDK_AVAILABLE_TYPE_IN_4_86
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_88
#define GDK_DEPRECATED_IN_4_88 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_88_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_88 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_88_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_88 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_88_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_88 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_88_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_88 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_88_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_88
#define GDK_DEPRECATED_MACRO_IN_4_88_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_88
#define GDK_DEPRECATED_ENUMERATOR_IN_4_88_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_88
#define GDK_DEPRECATED_TYPE_IN_4_88_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_88
#define GDK_AVAILABLE_IN_4_88 GDK_UNAVAILABLE (4, 88)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_88 GDK_UNAVAILABLE_STATIC_INLINE (4, 88)
#define GDK_AVAILABLE_MACRO_IN_4_88 GDK_UNAVAILABLE_MACRO (4, 88)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_88 GDK_UNAVAILABLE_ENUMERATOR (4, 88)
#define GDK_AVAILABLE_TYPE_IN_4_88 GDK_UNAVAILABLE_TYPE (4, 88)
#else
#define GDK_AVAILABLE_IN_4_88 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_88
#define GDK_AVAILABLE_MACRO_IN_4_88
#define GDK_AVAILABLE_ENUMERATOR_IN_4_88
#define GDK_AVAILABLE_TYPE_IN_4_88
#endif

#if GDK_VERSION_MIN_REQUIRED >= GDK_VERSION_4_90
#define GDK_DEPRECATED_IN_4_90 GDK_DEPRECATED
#define GDK_DEPRECATED_IN_4_90_FOR(f) GDK_DEPRECATED_FOR (f)
#define GDK_DEPRECATED_MACRO_IN_4_90 GDK_DEPRECATED_MACRO
#define GDK_DEPRECATED_MACRO_IN_4_90_FOR(f) GDK_DEPRECATED_MACRO_FOR (f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_90 GDK_DEPRECATED_ENUMERATOR
#define GDK_DEPRECATED_ENUMERATOR_IN_4_90_FOR(f) GDK_DEPRECATED_ENUMERATOR_FOR (f)
#define GDK_DEPRECATED_TYPE_IN_4_90 GDK_DEPRECATED_TYPE
#define GDK_DEPRECATED_TYPE_IN_4_90_FOR(f) GDK_DEPRECATED_TYPE_FOR (f)
#else
#define GDK_DEPRECATED_IN_4_90 _GDK_EXTERN
#define GDK_DEPRECATED_IN_4_90_FOR(f) _GDK_EXTERN
#define GDK_DEPRECATED_MACRO_IN_4_90
#define GDK_DEPRECATED_MACRO_IN_4_90_FOR(f)
#define GDK_DEPRECATED_ENUMERATOR_IN_4_90
#define GDK_DEPRECATED_ENUMERATOR_IN_4_90_FOR(f)
#define GDK_DEPRECATED_TYPE_IN_4_90
#define GDK_DEPRECATED_TYPE_IN_4_90_FOR(f)
#endif

#if GDK_VERSION_MAX_ALLOWED < GDK_VERSION_4_90
#define GDK_AVAILABLE_IN_4_90 GDK_UNAVAILABLE (4, 90)
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_90 GDK_UNAVAILABLE_STATIC_INLINE (4, 90)
#define GDK_AVAILABLE_MACRO_IN_4_90 GDK_UNAVAILABLE_MACRO (4, 90)
#define GDK_AVAILABLE_ENUMERATOR_IN_4_90 GDK_UNAVAILABLE_ENUMERATOR (4, 90)
#define GDK_AVAILABLE_TYPE_IN_4_90 GDK_UNAVAILABLE_TYPE (4, 90)
#else
#define GDK_AVAILABLE_IN_4_90 _GDK_EXTERN
#define GDK_AVAILABLE_STATIC_INLINE_IN_4_90
#define GDK_AVAILABLE_MACRO_IN_4_90
#define GDK_AVAILABLE_ENUMERATOR_IN_4_90
#define GDK_AVAILABLE_TYPE_IN_4_90
#endif
